#!/usr/bin/perl

require('./initiate.pl');
require('./config.pl');

use CGI ':standard';

print header;

flock(TEMP, 2);
open(TEMP, $template) or error("Cannot open $template: $!");

while (my $line = <TEMP>) {
	if ($line =~ /(.*)<QUIREX>(.*)/i) {
		print $1;
		
		if (param('action') eq "convert") {
			&ConvertDatabase;
			}
		elsif (param('action') eq "template") {
			&ConvertTemplate;
			}
		else {
			&ShowForm;
			}
		
		print $2;
		}
	else {
		print $line;
		}
	}

close(TEMP);
flock(TEMP, 8);

sub ConvertDatabase {

	$name         = param('name');
	$desc         = param('desc');
	$level        = param('level');
	$dbname       = param('dbname');
	$db_dir       = param('db_dir');
	$quiz_ques    = param('quiz_ques');
	$quiz_ans     = param('quiz_ans');
	$quiz_ans     = param('quiz_ans');
	$quiz_choices = param('quiz_choices');
	$quiz_desc    = param('quiz_desc');
	$quiz_last    = param('quiz_last');



	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=500 align=center><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=3><i><b>Quirex Addon - Converting Existing Database</b></i></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=2>This converter is used to convert a Quirex v1.x database to a v2.0 one</font></td></tr>\n";

	$err = 0;
	if ($name ne "") {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>Name OK</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>Name NOT OK</font></td></tr>\n"; $err=1;}
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>Description OK</font></td></tr>\n";
	if ($level =~ /^[0123]$/) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>Level OK</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>Level NOT OK</font></td></tr>\n"; $err=1;}
	if ($dbname =~ /^\w+$/) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>dbname OK</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>dbname NOT OK</font></td></tr>\n"; $err=1;}
	if (-w $db_dir) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>DB Directory exists and writtable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>DB Directory doesn't exist or non-writtable</font></td></tr>\n"; $err=1;}
	if (-r $quiz_ques) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_ques.txt exists and readable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_ques.txt doesn't exist or non-readable</font></td></tr>\n"; $err=1;}
	if (-r $quiz_ans) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_ans.txt exists and readable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_ans.txt doesn't exist or non-readable</font></td></tr>\n"; $err=1;}
	if (-r $quiz_choices) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_choices.txt exists and readable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_choices.txt doesn't exist or non-readable</font></td></tr>\n"; $err=1;}
	if (-r $quiz_desc) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_desc.txt exists and readable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_desc.txt doesn't exist or non-readable</font></td></tr>\n"; $err=1;}
	if (-r $quiz_last) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_last.txt exists and readable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_last.txt doesn't exist or non-readable</font></td></tr>\n"; $err=1;}

	open(FILE, $quiz_ques);
	@ques = <FILE>;
	close(FILE);

	$total = $#ques;

	open(FILE, $quiz_ans);
	@ans = <FILE>;
	close(FILE);

	open(FILE, $quiz_choices);
	@choices = <FILE>;
	close(FILE);

	open(FILE, $quiz_desc);
	@desc = <FILE>;
	close(FILE);

	open(FILE, ">>$db_dir/$dbname.db");
	for ($i=0;$i<=$total;$i++) {
		chomp($ques[$i]);
		chomp($ans[$i]);
		chomp($choices[$i]);
		chomp($desc[$i]);
		$qimage = "";
		$aimage = "";
		
		$qtype = ($choices[$i] eq "") ? "sa" : "mc";
		$choices[$i] =~ s/\|/\`\`/g;
		$ans[$i] =~ s/\|/\`\`/g;
		print FILE "$qtype\|\|$ques[$i]\|\|$qimage\|\|$ans[$i]\|\|$aimage\|\|$desc[$i]\|\|$choices[$i]\n";
		}
	close(FILE);

	open(FILE, $quiz_last);
	@last = <FILE>;
	close(FILE);

	open(FILE, ">>$db_dir/$dbname.rec");
	foreach $line (@last) {
		chomp($line);
		($att, $corr, $tname, $email) = split(/\|/, $line);
		$hide = "off";
		$hide = "on" if $email eq "";
		
		$tname = $tname || "Anonymous";
		$email = $email || "anonymous\@host.com";

		print FILE "$tname\|\|$email\|\|$hide\|\|$att\|\|$corr\|\|0\n";
		}
	close(FILE);


	open(LIST, ">>$db_dir/quirex.lst");
	print LIST "$dbname\|\|$name\|\|$desc\|\|$level\n";
	close(LIST);

	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>DONE!</b></font></td></tr>\n" if not $err;

	print "<tr><td bgcolor=$table{'color1'} align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v2.0</a></font></td></tr>\n";
	print "</table>\n";
	print "</td></tr></table>\n";

	}

sub ConvertTemplate {
	$quiz_head    = param('quiz_head');
	$quiz_foot    = param('quiz_foot');
	$template    = param('template');

	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=500 align=center><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=3><i><b>Quirex Addon - Converting Existing Database</b></i></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=2>This converter is used to convert a Quirex v1.x database to a v2.0 one</font></td></tr>\n";

	if (-r $quiz_head) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_head.txt exists and readable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_head.txt doesn't exist or non-readable</font></td></tr>\n"; $err=1;}
	if (-r $quiz_foot) {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_foot.txt exists and readable</font></td></tr>\n";}
		else {print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2>quiz_foot.txt doesn't exist or non-readable</font></td></tr>\n"; $err=1;}


	open(HEAD, $quiz_head);
	@head = <HEAD>;
	close(HEAD);

	open(FOOT, $quiz_foot);
	@foot = <FOOT>;
	close(FOOT);

	open(TEMP, ">$template");
	print TEMP @head;
	print TEMP "\n\n";
	print TEMP "<QUIREX>";
	print TEMP "\n\n";
	print TEMP @foot;
	close(TEMP);


	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>DONE!</b></font></td></tr>\n" if not $err;

	print "<tr><td bgcolor=$table{'color1'} align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v2.0</a></font></td></tr>\n";
	print "</table>\n";
	print "</td></tr></table>\n";

	}

sub ShowForm {
	$msg = shift;

	print "<form action=\"$script\" method=\"post\">\n";
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=500 align=center><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=3><i><b>Quirex Addon - Converting Existing Database</b></i></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'}><font$font_para size=2>This converter is used to convert a Quirex v1.x database to a v2.0 one</font></td></tr>\n";
	print "<tr><td bgcolor=#ff0000><font$font_para size=2><font color=#ffffff><b>$msg</b></font></font></td></tr>\n" if $msg ne "";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Name of the Quiz:</b> <input type=text name=name value=\"Default\" size=20></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Description of the Quiz:</b><br><input type=text name=desc size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Level of the Quiz:</b> <select name=level><option value=0><option value=1>$levelnames[1]<option value=2>$levelnames[2]<option value=3>$levelnames[3]</select></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>dbname of the Quiz:</b> <input type=text name=dbname value=\"default\" size=20><br><font size=1>Note: This must be a string containing only [a-z], [0-9] or underscore. e.g. 1stdegree, cgiquiz, my_test</font></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to Quirex v2.0 DB directory:</b><br><input type=text name=db_dir value=\"$db_dir\" size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to quiz_ques.txt:</b><br><input type=text name=quiz_ques size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to quiz_ans.txt:</b><br><input type=text name=quiz_ans size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to quiz_choices.txt:</b><br><input type=text name=quiz_choices size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to quiz_desc.txt:</b><br><input type=text name=quiz_desc size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to quiz_last.txt:</b><br><input type=text name=quiz_last size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'} align=center><font$font_para size=2><input type=submit value=\"Convert Database!\" style=\"background-color: $table{'color2'}; font-family: $font{'face'}\"></font></td></tr>\n";
	print "<input type=hidden name=action value=convert></form>\n";
	print "<form action=\"$script\" method=\"post\">\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to quiz_head.txt:</b><br><input type=text name=quiz_head size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Path to quiz_foot.txt:</b><br><input type=text name=quiz_foot size=50></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color2'} width=100%><font$font_para size=2><b>Output file:</b><br><input type=text name=template size=50 value=\"$template\"></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'} align=center><font$font_para size=2><input type=submit value=\"Convert Template!\" style=\"background-color: $table{'color2'}; font-family: $font{'face'}\"></font></td></tr>\n";
	print "<tr><td bgcolor=$table{'color1'} align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v2.0</a></font></td></tr>\n";
	print "</table>\n";
	print "</td></tr></table>\n";
	print "<input type=hidden name=action value=template></form>\n";

	}