sub getNumLine {
	my $file = shift;
	
	flock(2, REC);
	open(REC, "$db_dir/$file") or error("Cannot open $file: $!");
	my $i=0;
	while (<REC>) {
		$i++;
		}
	close(REC);
	flock(8, REC);
	
	return $i;
	}

sub getRecordHolder {
	my $dbname = shift;
	
	$highest_score = -1;
	$record_holder = "N/A";
	
	flock(2, REC);
	open(REC, "$db_dir/$dbname.rec") or error("Cannot open $dbname.db: $!");
	while (<REC>) {
		chomp($_);
		my ($name, $dump, $dump, $total, $correct, $dump) = split(/\|\|/, $_);
		$score = $correct / $total;
		if ($score >= $highest_score) {
			$highest_score = $score;
			$record_holder = $name;
			}
		}
	close(REC);
	flock(8, REC);
	
	return $record_holder;
	}

sub getQuizName {
	my $dbname = shift;

	flock(LIST, 2);
	open(LIST, "$db_dir/quirex.lst") or error("Cannot open quirex.lst: $!");
	while(<LIST>) {
		($db, $name, $dump, $dump) = split(/\|\|/, $_);
		$temp{$db} = $name;
		}
	close(LIST);
	flock(LIST, 8);	
	
	return $temp{$dbname} ne "" ? $temp{$dbname} : undef;
	
	}

sub getTime {
	my $time = shift;
	my @tt = localtime($time);
	return (1900 + $tt[5])."-".($tt[4]+1)."-$tt[3] $tt[2]:$tt[1]:$tt[0]";

	}

sub QuizExists {
	my $quiz = shift;
	
	$exists = 0;
	flock(LIST, 2);
	open(LIST, "$db_dir/quirex.lst") or error("Cannot open quirex.lst: $!");
	while(<LIST>) {
		($db, $dump, $dump, $dump) = split(/\|\|/, $_);
		$exists = 1 if $db eq $quiz;
		}
	close(LIST);
	flock(LIST, 8);	

	return $exists;
	}

sub error {

	print "<table border=1 cellspacing=0 cellpadding=3 bordercolor=#000000 bgcolor=#ffffff>\n";
	print "\t<tr><td valign=middle><font face=Arial size=2><b>ERROR:</b></font></td></tr>";
	print "\t<tr><td valign=middle><font face=Arial size=2><b>";
	print shift;
	print "</font></td></tr>\n";
	print "</table>\n";

}

1;
