sub ShowRecords {
	my $quiz = shift;
	my $parameter = shift;
	if ($parameter =~ /^recent(\d*)$/) {
		&ShowRecentRecords($quiz, $1);
		}
	if ($parameter =~ /^top(\d*)$/) {
		&ShowTopRecords($quiz, $1);
		}
	}
	
sub ShowRecentRecords {
	my $quiz = shift;
	my $num = shift;
	$num = $num || &getNumLine("$quiz.rec");
	
	flock(2, REC);
	open(REC, "$db_dir/$quiz.rec") or error("Cannot open $quiz.rec: $!");
	@lines = <REC>;
	close(REC);
	flock(8, REC);
	
	while ($#lines >= $num) {
		shift(@lines);
		}
	
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=95%><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td colspan=5 bgcolor=$table{'color1'}><font$font_para size=3><i><b>Recent $num Quiz Takers</b></i></font></td></tr>\n";
	print "<tr><td colspan=5 bgcolor=$table{'color1'}><font$font_para size=2><b>Quiz Name: ".getQuizName($quiz)."</b></font></td></tr>\n";
	print "<tr bgcolor=$table{'color1'}><td align=center><font$font_para size=2><b>Name</b></font></td><td align=center><font$font_para size=2><b>Ques Attemped</b></font></td><td align=center><font$font_para size=2><b>Ques Correct</b></font></td><td align=center><font$font_para size=2><b>Score</b></font></td><td align=center><font$font_para size=2><b>Time</b></font></td></tr>\n";
	
	
	$i = 1;
	foreach $line (reverse @lines) {
		chomp($line);
		my ($name,$email,$hide,$total,$correct,$time) = split(/\|\|/, $line);
		my $score2d = int(($correct/$total)*10000 + 0.5)/100;

		my $j = 'color' . (($i % 2) + 1);

		print "<tr bgcolor=$table{$j}>";
		if ($hide eq "on") {
			print "<td><font$font_para size=2>$name</font></td>";
			}
		else {
			print "<td><font$font_para size=2><a href=\"mailto:$email\">$name</a></font></td>";
			}
		print "<td align=center><font$font_para size=2>$total</font></td>";
		print "<td align=center><font$font_para size=2>$correct</font></td>";
		print "<td align=center><font$font_para size=2>$score2d</font></td>";
		print "<td align=center><font$font_para size=2>".getTime($time)."</font></td>";
		print "</tr>\n";

		$i++;
		}


	print "<tr bgcolor=$table{'color1'}><td colspan=5 align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v$version</a></font></td></tr>\n" if $show_copyright;
	print "</table>\n";
	print "</td></tr></table>\n";

	}
	
sub ShowTopRecords {
	my $quiz = shift;
	my $num = shift;
	my $num_line = &getNumLine("$quiz.rec");
	$num = $num || $num_line;
	
	$num = $num_line if $num > $num_line;
	
	flock(2, REC);
	open(REC, "$db_dir/$quiz.rec") or error("Cannot open $quiz.rec: $!");
	@lines = <REC>;
	close(REC);
	flock(8, REC);

	@sorted = sort {
		chomp($a);
		chomp($b);
		my ($name_a,$dump,$dump,$total_a,$correct_a,$time_a) = split(/\|\|/, $a);
		my ($name_b,$dump,$dump,$total_b,$correct_b,$time_b) = split(/\|\|/, $b);
		my $score_a = $correct_a/$total_a;
		my $score_b = $correct_b/$total_b;
		$score_b <=> $score_a || $time_b <=> $time_a || lc($name_a) cmp lc($name_b);
		}
		@lines;


	
	print "<table border=0 cellspacing=0 cellpadding=1 bgcolor=#000000 width=95%><tr><td>\n";
	print "<table border=0 cellspacing=1 cellpadding=1 width=100%>\n";
	print "<tr><td colspan=5 bgcolor=$table{'color1'}><font$font_para size=3><i><b>Top $num Quiz Takers</b></i></font></td></tr>\n";
	print "<tr><td colspan=5 bgcolor=$table{'color1'}><font$font_para size=2><b>Quiz Name: ".getQuizName($quiz)."</b></font></td></tr>\n";
	print "<tr bgcolor=$table{'color1'}><td align=center><font$font_para size=2><b>Name</b></font></td><td align=center><font$font_para size=2><b>Ques Attemped</b></font></td><td align=center><font$font_para size=2><b>Ques Correct</b></font></td><td align=center><font$font_para size=2><b>Score</b></font></td><td align=center><font$font_para size=2><b>Time</b></font></td></tr>\n";
	
	
	$i = 1;
	for($k=0;$k<$num;$k++) {
		chomp($line[$k]);
		my ($name,$email,$hide,$total,$correct,$time) = split(/\|\|/, $sorted[$k]);
		my $score2d = int(($correct/$total)*10000 + 0.5)/100;

		my $j = 'color' . (($i % 2) + 1);

		print "<tr bgcolor=$table{$j}>";
		if ($hide eq "on") {
			print "<td><font$font_para size=2>$name</font></td>";
			}
		else {
			print "<td><font$font_para size=2><a href=\"mailto:$email\">$name</a></font></td>";
			}
		print "<td align=center><font$font_para size=2>$total</font></td>";
		print "<td align=center><font$font_para size=2>$correct</font></td>";
		print "<td align=center><font$font_para size=2>$score2d</font></td>";
		print "<td align=center><font$font_para size=2>".getTime($time)."</font></td>";
		print "</tr>\n";

		$i++;
		}


	print "<tr bgcolor=$table{'color1'}><td colspan=5 align=right><font$font_para size=1>Powered by <a href=\"http://www.cgihk.com\">Quirex v$version</a></font></td></tr>\n" if $show_copyright;
	print "</table>\n";
	print "</td></tr></table>\n";

	}

1;
